import numpy as np
import pylab as pl
import os

SOURCES = ['1803+784','1849+670','2229+695','0059+581','0613+570','3C418','OJ287']
EXPERIMENT = 'VO2187'

DTMAX = 10.0
NCHAN = 160
TAVER = '10s'

for si in SOURCES:
    os.system('rm -rf %s_%s_AVER.ms'%(EXPERIMENT,si))
    os.system('rm -rf TEMP.ms')
    importfitsidi(fitsidifile = 'GFF_CAL_%s.fits'%si,
                  vis = 'TEMP.ms')

## INDXR:
    tb.open('TEMP.ms',nomodify=False)
    TIME = tb.getcol("TIME")
    SCAN = tb.getcol("SCAN_NUMBER")
    UTIME = np.unique(TIME)

    SCANS = []
    t0 = UTIME[0]
    for ti in range(len(UTIME)-1):
        if UTIME[ti+1]-UTIME[ti] > DTMAX:
            SCANS.append([t0,UTIME[ti]])
            t0 = UTIME[ti+1]
    SCANS.append([t0,UTIME[-1]])

    MASK = np.zeros(len(TIME),dtype=bool)
    for s,sci in enumerate(SCANS):
        MASK[:] = np.logical_and(TIME>=sci[0], TIME<=sci[1])
        SCAN[MASK] = s+1

    tb.putcol("SCAN_NUMBER",SCAN)
    tb.close()

## ANT. NAMES:
    tb.open('TEMP.ms/ANTENNA',nomodify=False)
    NAM = tb.getcol('NAME')
    STA = tb.getcol('STATION')
    NAM[:] = STA
    tb.putcol('NAME',NAM)
    tb.close()


## Average in frequency:
    split(vis = 'TEMP.ms',
          outputvis = '%s_%s_AVER.ms'%(EXPERIMENT,si),
          datacolumn = 'data',
          width = NCHAN,
          timebin = TAVER)

    os.system('rm -rf TEMP.ms')
