import numpy as np
import pylab as pl
import os,sys


mysteps = [0,1,2]
mysteps = [3]

EXPERIMENT = 'VO2187 @ 5GHz'
VIS = 'Cl_VO2187_AMPCAL.ms'
OUTVIS = 'SELFCAL_'+VIS


IMSIZE = 512; CELL = '0.0001arcsec'
ROBUST = 2.0; NSELFCAL = 5; NITER = 5000
GAIN = 0.02; REFNU = '5GHz'


#Cut['3C418'] = 3.0


tb.open(os.path.join(OUTVIS,'FIELD'))
SOURCES = list(tb.getcol('NAME'))
tb.close()

tb.open(os.path.join(OUTVIS,'ANTENNA'))
ANTENNAS = list(tb.getcol('NAME'))
tb.close()


dPol = 4; lPol = 1.0
mCut = {}; Cut = {}
Zoom = {}; zCenter = {}
for sou in SOURCES:
 #   if sou not in SOURCES.keys():
        mCut[sou] = 2.0
        Cut[sou] = 3.0
        Zoom[sou] = 4.0
        zCenter[sou] = [0,0]

Zoom['1849+670'] = 8.0
mCut['1849+670'] = 1.0
Cut['1849+670'] = 2.0

Zoom['1803+784'] = 8.0*3./2.


thesteps = {0: "Split out.",
            1: "PolSolve in selfcal mode.",
            2: "Split out full-cal data & CLEAN.",
            3: "Make final images."}



if 0 in mysteps:
    print(thesteps[0])
    os.system('rm -rf %s*'%OUTVIS)
    split(vis=VIS,outputvis=OUTVIS,datacolumn='corrected')




if 1 in mysteps:
    clearcal(vis=OUTVIS,addmodel=True)
    for i in range(NSELFCAL):
        print("\n\n\n      DOING POLSOLVE ITERATION %i\n"%(i+1))
        os.system('rm -rf TEST.ms')
        split(vis=OUTVIS, datacolumn='corrected',outputvis='TEST.ms')
        clearcal(vis='TEST.ms',addmodel=True)
        for sou in SOURCES:
            os.system('rm -rf %s_CLEAN.*'%sou)
            if not os.path.exists('%s_PSOLVE.msk'%sou):
                MASK = ''; INTERAC = True
            else:
                INTERAC = False
                MASK = '%s_PSOLVE.msk'%sou
            tclean(vis='TEST.ms', imagename='%s_CLEAN'%sou,
                   field=sou, datacolumn='corrected',
                   specmode='mfs', niter=NITER,
                   interactive=INTERAC, reffreq=REFNU,
                   imsize=IMSIZE, cell=CELL,
                   stokes='IQUV', usemask='user', mask=MASK,
                   weighting='briggs', robust=ROBUST,
                   deconvolver='hogbom',gain=GAIN,restart=False)
            os.system('rm -rf %s_PSOLVE.msk'%sou)
            os.system('cp -r %s_CLEAN.mask %s_PSOLVE.msk'%(sou,sou))
        os.system('rm -rf %s.*Dterms'%OUTVIS)
        polsolve(vis=OUTVIS, field=','.join(SOURCES),
                 target_field=','.join(SOURCES),
                 isLinear = [True for ani in ANTENNAS],
                 CLEAN_models=['%s_CLEAN.model'%si for si in SOURCES],
                 linear_approx=False, nterms=-1)
    FINALVIS = "%s_DTCAL"%OUTVIS
    os.system("rm -rf %s"%FINALVIS)
    split(vis=OUTVIS,datacolumn='corrected',outputvis=FINALVIS)



if 2 in mysteps:
    for sou in SOURCES:
        os.system('rm -rf %s_FINAL.*'%sou)
        if not os.path.exists('%s_PSOLVE.msk'%sou):
            MASK = ''; INTERAC = True
        else:
            INTERAC = False
            MASK = '%s_PSOLVE.msk'%sou
        tclean(vis='TEST.ms', imagename='%s_FINAL'%sou,
               field=sou, datacolumn='corrected', 
               specmode='mfs', niter=NITER,
               interactive=INTERAC, reffreq=REFNU,
               imsize=IMSIZE, cell=CELL,
               stokes='IQUV', usemask='user', mask=MASK,
               weighting='briggs', robust=ROBUST,
               deconvolver='hogbom',gain=GAIN,restart=False)


if 3 in mysteps:
    for sou in SOURCES: #[:1]:
        print('\nMAKING IMAGE OF SOURCE: %s'%sou)
        ia.open('%s_FINAL.image'%sou) 
        IM0 = ia.getchunk(); Ipk = np.max(IM0)
        
        myFig,mySub,myCont,myPol = plotPolImage('%s_FINAL.image'%sou,
                     mSigmaCut = mCut[sou],
                     levs = 10,
                     SigmaCut = Cut[sou],
                     title = '%s - %s'%(EXPERIMENT,sou),
                     dPol = dPol, lPol = lPol,
                     figName = '%s_PolImg.png'%sou,
                     zoom = Zoom[sou], zoomCenter = zCenter[sou])

        cbAX = myFig.add_axes([0.05,0.11,0.90,0.03])
        cbar = pl.colorbar(myPol,cax=cbAX,orientation='horizontal')
        cbar.set_label('Pol. Intensity (mJy/beam)')
        myFig.subplots_adjust(bottom=0.25,right=0.85)
#        myFig.colorbar(myPol)
        pl.savefig('%s_PolImg.png'%sou)
